
From: Andrew Hendry <ahendry@tusc.com.au>

route add --x25 0/0 eth0
cat /proc/net/x25/route
reads the single routing entry forever.

This patch makes x25_get_route_idx behave the same as x25_get_socket_idx
which works correctly.

Signed-off-by: Andrew Hendry <ahendry@tusc.com.au>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/net/x25/x25_proc.c |    7 ++++---
 1 files changed, 4 insertions(+), 3 deletions(-)

diff -puN net/x25/x25_proc.c~x25-stop-proc-net-x25-route-infinitely net/x25/x25_proc.c
--- 25/net/x25/x25_proc.c~x25-stop-proc-net-x25-route-infinitely	2004-10-26 18:45:01.164723712 -0700
+++ 25-akpm/net/x25/x25_proc.c	2004-10-26 18:45:01.169722952 -0700
@@ -32,10 +32,11 @@ static __inline__ struct x25_route *x25_
 
 	list_for_each(route_entry, &x25_route_list) {
 		rt = list_entry(route_entry, struct x25_route, node);
-		if (--pos)
-			break;
+		if (!pos--)
+			goto found;
 	}
-
+	rt = NULL;
+found:
 	return rt;
 }
 
_
